#ifndef _POP3C_H_
#define _POP3C_H_

#include <stdio.h>

#include <sys/socket.h>

#define MAX_HEADERLINELEN   80
#define MAX_ROUTE_IP        10

typedef struct {
    TCPSOCKET *pops_sock;
    FILE *pops_stream;
    char pops_buff[512];
} POP3SESSION;

typedef struct {
    char *poph_to;
    char *poph_from;
    char *poph_reply_to;
    char *poph_return_path;
    char *poph_subject;
    char *poph_date;
    u_char poph_route_num;
    u_long popm_route_ip[MAX_ROUTE_IP];
} POP3HEADER;

extern POP3SESSION *NutPop3Open(CONST char *host, CONST char *user, CONST char *pass, u_long tmo);
extern void NutPop3Close(POP3SESSION *pops);

extern int NutPop3Command(POP3SESSION *pops, CONST char *fmt, ...);
extern char *NutPop3GetArg(POP3SESSION *pops, int num);
extern int NutPop3GetLines(POP3SESSION *pops, char *buff, size_t size);
extern int NutPop3Status(POP3SESSION *pops, int num, u_long *sizep);

extern POP3HEADER *NutPop3Header(POP3HEADER *poph);
extern int NutPop3Retrieve(POP3SESSION *pops, int mno, POP3HEADER *poph, char *buff, size_t size);

#endif
