#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <arpa/inet.h>
#include <netdb.h>

#include "pop3c.h"
#include "score.h"

char dnsbl_domain[128];
int dnsbl_score;
SCORELIST *list_to;
SCORELIST *list_from;
SCORELIST *list_subject;

/*
 *
 */
int AddScore(char *str, int val, SCORELIST **list)
{
    SCORELIST *lp;

    if((lp = malloc(sizeof(SCORELIST))) != 0) {
        if((lp->scol_str = malloc(strlen(str) + 1)) == 0) 
            free(lp);
        else {
            strcpy(lp->scol_str, str);
            lp->scol_val = val;
            lp->scol_nxt = *list;
            *list = lp;
            return 0;
        }
    }
    return -1;
}

/*
 *
 */
int DelScore(char *str, SCORELIST **list)
{
    SCORELIST *lp;
    SCORELIST **lpp;

    lpp = list;
    lp = *list;

    while (lp) {
        if (strcmp(lp->scol_str, str) == 0) {
            *lpp = lp->scol_nxt;
            free(lp->scol_str);
            free(lp);
            return 0;
        }
        lpp = (SCORELIST **)&lp->scol_nxt;
        lp = lp->scol_nxt;
    }
    return -1;
}


static int ScoreContents(CONST char *str, SCORELIST *list)
{
    int score = 0;

    while(list) {
        if(strstr(str, list->scol_str))
            score += list->scol_val;
        list = list->scol_nxt;
    }
    return score;
}

static int ScoreDnsBlockList(u_long *ip, char num)
{
    int score = 0;
    u_char i;
    char *buff;
    
    if(dnsbl_score < 0 && (buff = malloc(strlen(dnsbl_domain) + 17)) != 0) {
        for(i = 0; i < num; i++, ip++) {
            sprintf(buff, "%s.%s", inet_ntoa(htonl(*ip)), dnsbl_domain);
            if(NutDnsGetHostByName(buff))
                score += dnsbl_score;
        }
        free(buff);
    }
    return score;
}

/*
 *
 */
int Score(POP3HEADER *poph)
{
    int score;

    score = ScoreContents(poph->poph_to, list_to);
    score += ScoreContents(poph->poph_from, list_from);
    score += ScoreContents(poph->poph_reply_to, list_from);
    score += ScoreContents(poph->poph_return_path, list_from);
    score += ScoreContents(poph->poph_subject, list_subject);
    if(score >= 0)
        score += ScoreDnsBlockList(poph->popm_route_ip, poph->poph_route_num);

    return score;
}
